#!/bin/sh
#
#  nassync by gutemine  
#
VERSION=1.6
#
# change to your NAS mount point here:
#
NAS=/media/nas
#
# other example could be:
#
#NAS=/automount/nas
#
MOVIE=/media/hdd/movie
#
NASSYNCSCRIPT="/usr/lib/enigma2/python/Plugins/Extensions/NASsync/nassync.sh"
NASDIR="/usr/lib/enigma2/python/Plugins/Extensions/NASsync/.nasdir"
MOVIEDIR="/usr/lib/enigma2/python/Plugins/Extensions/NASsync/.moviedir"
#
NASTMP=/tmp/.nastmp
MYTMP=/tmp/.mytmp
CRONTABTMP=/tmp/.crontabtmp
CRONTABTMP2=/tmp/.crontabtmp2
NASTMP2=/tmp/.nastmp2
MOVIETMP=/tmp/.movietmp
MOVIETMP2=/tmp/.movietmp2
NTMP=/tmp/.ntmp
MTMP=/tmp/.mtmp

COMMAND="usage"
#wall $1 $2
LINE="--------------------------------------------------------"
if [ $# -gt 0 ]; then
   COMMAND=$1
fi
if [ -f $NASDIR ]; then
   NAS=`cat $NASDIR`
fi
if [ -f $MOVIEDIR ]; then
   MOVIE=`cat $MOVIEDIR`
fi
# 
# check for instant crontab
#
if [ $COMMAND = "nas2movie" -o $COMMAND = "pc2movie" -o $COMMAND = "backup" -o $COMMAND = "movie2nas" -o $COMMAND = "restore" -o $COMMAND = "movie2pc" -o  $COMMAND = "sync" -o $COMMAND = "archive" ]; then
crontab -l > $CRONTABTMP
if [ `grep "\* \* \* \* \* $NASSYNCSCRIPT" $CRONTABTMP | wc -l` -gt 0 ]; then
   echo $LINE
   echo "Removing Instant Crontab Entry - probably myself: $0 $1 $2"
   wall "Removing Instant Crontab Entry - probably myself: $0 $1 $2"
   grep -v "\* \* \* \* \* $NASSYNCSCRIPT" $CRONTABTMP > $CRONTABTMP2
   crontab $CRONTABTMP2
   crontab -l 
fi
fi

#echo "nassync.sh $COMMAND $NAS $MOVIE"
if [ `ps | grep nassync | wc -l` -gt 3 ]; then
   echo $LINE
   echo "nassync.sh already running, try again"
   echo $LINE
   exit 1
fi
if [ ! -d $NAS ]; then
   echo $LINE
   echo "NAS directory $NAS doesn't exist !"
   echo $LINE
   exit 1
fi
if [ ! -d $MOVIE ]; then
   echo $LINE
   echo "Movie directory $MOVIE doesn't exist !"
   echo $LINE
   exit 1
fi
touch $NAS/dummy 
if [ -f $MOVIE/dummy ]; then
   echo $LINE
   echo "NAS directory $NAS and Movie directory"
   echo "$MOVIE cann't be identical !"
   echo $LINE
   rm $NAS/dummy > /dev/null 2>&1
   exit 1
fi
rm $NAS/dummy > /dev/null 2>&1

cd $MOVIE
ls -1 > $MOVIETMP
MOVIENUMBER=`cat $MOVIETMP | wc -l`
cd $NAS
ls -1 > $NASTMP
NASNUMBER=`cat $NASTMP | wc -l`

case $COMMAND in
v | version )
   echo $LINE
   echo "NAS Syncronisation script by gutemine Version $VERSION"
   echo
   echo "NAS = Network Attached Storage"
   echo $LINE
   exit 0
   ;;
crontab )
   echo "Showing NAS Syncronisation crontab entries"
   echo $LINE
   crontab -l | grep $NASSYNCSCRIPT
   ;;
rmcrontab )
   echo $LINE
   echo "Removing all NAS Syncronisation crontab entries"
   crontab -l > $CRONTABTMP
   grep -v $NASSYNCSCRIPT $CRONTABTMP > $CRONTABTMP2
   crontab $CRONTABTMP2
   ;;
status | moviestatus )
   if [ $# -lt 2 ]; then
      echo $LINE
      echo "Movie Syncronisation Status"
      echo $LINE
   fi
   grep -v ".eit" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".ap" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".meta" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".cuts" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".eit" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".ap" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".cuts" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".movie" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   MOVIENUMBER=`cat $MOVIETMP | wc -l`
   NASNUMBER=`cat $NASTMP | wc -l`
   X=1
   cd $MOVIE
   while [ $X -le $MOVIENUMBER ]; do
   FILE=`head -n $X $MOVIETMP | tail -n 1`
   grep -v "$FILE" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP 
   OUTPUT=`ls "$FILE"`
   if [ `ls -p "$FILE" | grep "@" | wc -l` -gt 0 ]; then
      echo "$OUTPUT -> NAS"  
   else
      if [ -f "$NAS/$FILE" ]; then
         echo "$OUTPUT BOTH" 
      else
         echo "$OUTPUT MOVIE"  
      fi
   fi
   X=`expr $X "+" 1`
   done
   X=1
   cd $NAS
   NASNUMBER=`cat $NASTMP | wc -l`
   while [ $X -le $NASNUMBER ]; do
   FILE=`head -n $X $NASTMP | tail -n 1`
   OUTPUT=`ls "$FILE"`
   if [ `ls -p "$FILE" | grep "@" | wc -l` -gt 0 ]; then
      echo "$OUTPUT -> MOVIE"  
   else
      if [ -f "$MOVIE/$FILE" ]; then
         echo "$OUTPUT BOTH" 
      else
         echo "$OUTPUT NAS"  
      fi
   fi
   X=`expr $X "+" 1`
   done
   if [ $# -gt 1 ]; then
      exit 0
   fi
;;
fullstatus )
   echo $LINE
   echo "Full Syncronisation Status"
   echo $LINE
   X=1
   cd $MOVIE
   while [ $X -le $MOVIENUMBER ]; do
   FILE=`head -n $X $MOVIETMP | tail -n 1`
   grep -v "$FILE" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP 
   OUTPUT=`ls "$FILE"`
   if [ `ls -p "$FILE" | grep "@" | wc -l` -gt 0 ]; then
      echo "$OUTPUT -> NAS"  
   else
      if [ -f "$NAS/$FILE" ]; then
         echo "$OUTPUT BOTH" 
      else
         echo "$OUTPUT MOVIE"  
      fi
   fi
   X=`expr $X "+" 1`
   done
   X=1
   cd $NAS
   NASNUMBER=`cat $NASTMP | wc -l`
   while [ $X -le $NASNUMBER ]; do
   FILE=`head -n $X $NASTMP | tail -n 1`
   OUTPUT=`ls "$FILE"`
   if [ `ls -p "$FILE" | grep "@" | wc -l` -gt 0 ]; then
      echo "$OUTPUT -> MOVIE"  
   else
      if [ -f "$MOVIE/$FILE" ]; then
         echo "$OUTPUT BOTH" 
      else
         echo "$OUTPUT NAS"  
      fi
   fi
   X=`expr $X "+" 1`
   done
;;
ls | list )
   if [ $# -gt 1 ]; then
      echo "$2" > $MYTMP
      sed -ie s!"'"!""!g /$MYTMP
      ARG=`cat $MYTMP`
      grep "$ARG" $MOVIETMP > $MOVIETMP2
      cp $MOVIETMP2 $MOVIETMP
      grep "$ARG" $NASTMP > $NASTMP2
      cp $NASTMP2 $NASTMP
   fi
   grep -v ".eit" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".ap" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".meta" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".cuts" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   MOVIENUMBER=`cat $MOVIETMP | wc -l`
   
   grep -v ".eit" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".ap" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".meta" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".cuts" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   NASNUMBER=`cat $NASTMP | wc -l`
   
   echo $LINE
   echo "Listing of $ARG at $MOVIE"
   echo $LINE
   X=1
   cd $MOVIE
   while [ $X -le $MOVIENUMBER ]; do
   FILE=`head -n $X $MOVIETMP | tail -n 1`
   OUTPUT=`du -h "$FILE"`
   if [ `ls -p "$FILE" | grep "@" | wc -l` -gt 0 ]; then
      echo "$OUTPUT -> $NAS"  
   else
      echo "$OUTPUT"  
   fi
   X=`expr $X "+" 1`
   done
   echo $LINE
   echo "Listing of $ARG at $NAS"
   echo $LINE
   X=1
   cd $NAS
   while [ $X -le $NASNUMBER ]; do
   FILE=`head -n $X $NASTMP | tail -n 1`
   OUTPUT=`du -h "$FILE"`
   if [ `ls -p "$FILE" | grep "@" | wc -l` -gt 0 ]; then
      echo "$OUTPUT -> $MOVIE"  
   else
      echo "$OUTPUT"  
   fi
   X=`expr $X "+" 1`
   done
;;
lsnas | listnas )
   if [ $# -gt 1 ]; then
      echo "$2" > $MYTMP
      sed -ie s!"'"!""!g /$MYTMP
      ARG=`cat $MYTMP`
      grep "$ARG" $NASTMP > $NASTMP2
      cp $NASTMP2 $NASTMP
   fi
   
   grep -v ".eit" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".ap" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".meta" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   grep -v ".cuts" $NASTMP > $NASTMP2
   cp $NASTMP2 $NASTMP
   NASNUMBER=`cat $NASTMP | wc -l`
   
   echo $LINE
   echo "Listing of $ARG at $NAS"
   echo $LINE
   X=1
   cd $NAS
   while [ $X -le $NASNUMBER ]; do
   FILE=`head -n $X $NASTMP | tail -n 1`
   OUTPUT=`du -h "$FILE"`
   if [ `ls -p "$FILE" | grep "@" | wc -l` -gt 0 ]; then
      echo "$OUTPUT -> $MOVIE"  
   else
      echo "$OUTPUT"  
   fi
   X=`expr $X "+" 1`
   done
;;
lsmovie | listmovie )
   if [ $# -gt 1 ]; then
      echo "$2" > $MYTMP
      sed -ie s!"'"!""!g /$MYTMP
      ARG=`cat $MYTMP`
      grep "$ARG" $MOVIETMP > $MOVIETMP2
      cp $MOVIETMP2 $MOVIETMP
   fi
   grep -v ".eit" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".ap" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".meta" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   grep -v ".cuts" $MOVIETMP > $MOVIETMP2
   cp $MOVIETMP2 $MOVIETMP
   MOVIENUMBER=`cat $MOVIETMP | wc -l`
   
   echo $LINE
   echo "Listing of $ARG at $MOVIE"
   echo $LINE
   X=1
   cd $MOVIE
   while [ $X -le $MOVIENUMBER ]; do
   FILE=`head -n $X $MOVIETMP | tail -n 1`
   OUTPUT=`du -h "$FILE"`
   if [ `ls -p "$FILE" | grep "@" | wc -l` -gt 0 ]; then
      echo "$OUTPUT -> $NAS"  
   else
      echo "$OUTPUT"  
   fi
   X=`expr $X "+" 1`
   done
;;

movie2nas | backup | movie2pc )
   if [ $# -gt 1 ]; then
      echo "$2" > $MYTMP
      sed -ie s!"'"!""!g /$MYTMP
      ARG=`cat $MYTMP`
      grep "$ARG" $MOVIETMP > $MOVIETMP2
      cp $MOVIETMP2 $MOVIETMP
      MOVIENUMBER=`cat $MOVIETMP | wc -l`
   fi
   echo $LINE
   echo "coping $ARG from $MOVIE to $NAS"
   echo $LINE
   if [ $MOVIENUMBER -eq 0 ]; then
      echo "no movie found at $MOVIE"
      echo $LINE
      exit 0
   fi
   X=1
   cd $MOVIE
   while [ $X -le $MOVIENUMBER ]; do
   FILE=`head -n $X $MOVIETMP | tail -n 1`
   if [ ! -f "$NAS/$FILE" ]; then
      echo "Copying $FILE to $NAS"
      cp "$FILE" $NAS
   else
      ls -s "$FILE" >  $MTMP 
      sed -ie s!"$FILE"!""!g $MTMP
      cd $NAS
      ls -s "$FILE" >  $NTMP 
      sed -ie s!"$FILE"!""!g $NTMP
      cd $MOVIE
      MSIZE=`cat $MTMP`
      NSIZE=`cat $NTMP`
      if [ $NSIZE -lt $MSIZE ]; then
         if [ `ls -p "$NAS/$FILE" | grep @ | wc -l` -gt 0 ]; then
            echo "$FILE at $NAS seems to be link, re-copy"
         else
            echo "$FILE at $NAS seems incomplete, re-copy"
         fi 
         rm "$NAS/$FILE" > /dev/null 2>&1
         cp "$FILE" $NAS
      else
         echo "$FILE already at $NAS"
      fi
   fi
   X=`expr $X "+" 1`
   done
;;

nas2movie | restore | pc2movie )
   if [ $# -gt 1 ]; then
      echo "$2" > $MYTMP
      sed -ie s!"'"!""!g /$MYTMP
      ARG=`cat $MYTMP`
      grep "$ARG" $NASTMP > $NASTMP2
      cp $NASTMP2 $NASTMP
      NASNUMBER=`cat $NASTMP | wc -l`
   fi
   echo $LINE
   echo "coping $ARG from $NAS to $MOVIE"
   echo $LINE
   if [ $NASNUMBER -eq 0 ]; then
      echo "no movie found at $NAS"
      echo $LINE
      exit 0
   fi
   X=1
   cd $NAS
   while [ $X -le $NASNUMBER ]; do
   FILE=`head -n $X $NASTMP | tail -n 1`
   if [ ! -f "$MOVIE/$FILE" ]; then
      echo "Copying $FILE to $MOVIE"
      cp "$FILE" $MOVIE
   else
      ls -s "$FILE" >  $NTMP 
      sed -ie s!"$FILE"!""!g $NTMP
      cd $MOVIE
      ls -s "$FILE" >  $MTMP 
      sed -ie s!"$FILE"!""!g $MTMP
      cd $NAS
      MSIZE=`cat $MTMP`
      NSIZE=`cat $NTMP`
      if [ $MSIZE -lt $NSIZE ]; then
         if [ `ls -p "$MOVIE/$FILE" | grep @ | wc -l` -gt 0 ]; then
            echo "$FILE at $MOVIE seems to be link, re-copy"
         else
            echo "$FILE at $MOVIE seems incomplete, re-copy"
         fi 
         rm "$MOVIE/$FILE" > /dev/null 2>&1
         cp "$FILE" $MOVIE
      else
         echo "$FILE already at $MOVIE"
      fi
   fi
   X=`expr $X "+" 1`
   done
;;

rmmovie | deletemovie )
   if [ $# -gt 1 ]; then
      echo "$2" > $MYTMP
      sed -ie s!"'"!""!g /$MYTMP
      ARG=`cat $MYTMP`
      grep "$ARG" $MOVIETMP > $MOVIETMP2
      cp $MOVIETMP2 $MOVIETMP
      MOVIENUMBER=`cat $MOVIETMP | wc -l`
   fi
   echo $LINE
   echo "removing $ARG at $MOVIE"
   echo $LINE
   if [ $MOVIENUMBER -eq 0 ]; then
      echo "no movie found at $MOVIE"
      echo $LINE
      exit 0
   fi
   cd $MOVIE
   X=1
   while [ $X -le $MOVIENUMBER ]; do
   FILE=`head -n $X $MOVIETMP | tail -n 1`
   if [ ! -f "$NAS/$FILE" ]; then
      echo "no remaining $FILE at $NAS, sorry"
   else
      ls -s "$FILE" >  $MTMP 
      sed -ie s!"$FILE"!""!g $MTMP
      cd $NAS
      ls -s "$FILE" >  $NTMP 
      sed -ie s!"$FILE"!""!g $NTMP
      cd $MOVIE
      MSIZE=`cat $MTMP`
      NSIZE=`cat $NTMP`
      if [ $NSIZE -lt $MSIZE ]; then
         echo "remaining $FILE at $NAS seems incomplete or link, sorry"
      else
         echo "$FILE removed at $MOVIE"
         rm "$MOVIE/$FILE"  > /dev/null 2>&1
      fi
   fi
   X=`expr $X "+" 1`
   done
;;

rmnas | deletenas | deletepc )
   if [ $# -gt 1 ]; then
      echo "$2" > $MYTMP
      sed -ie s!"'"!""!g /$MYTMP
      ARG=`cat $MYTMP`
      grep "$ARG" $NASTMP > $NASTMP2
      cp $NASTMP2 $NASTMP
      NASNUMBER=`cat $NASTMP | wc -l`
   fi
   echo $LINE
   echo "removing $ARG at $NAS"
   echo $LINE
   if [ $NASNUMBER -eq 0 ]; then
      echo "no movie found at $NAS"
      echo $LINE
      exit 0
   fi
   cd $NAS
   X=1
   while [ $X -le $NASNUMBER ]; do
   FILE=`head -n $X $NASTMP | tail -n 1`
   if [ ! -f "$MOVIE/$FILE" ]; then
      echo "no remaining $FILE at $MOVIE, sorry"
   else
      ls -s "$FILE" >  $NTMP 
      sed -ie s!"$FILE"!""!g $NTMP
      cd $MOVIE
      ls -s "$FILE" >  $MTMP 
      sed -ie s!"$FILE"!""!g $MTMP
      cd $NAS
      MSIZE=`cat $MTMP`
      NSIZE=`cat $NTMP`
      if [ $MSIZE -lt $NSIZE ]; then
         echo "remaining $FILE at $MOVIE seems incomplete or link, sorry"
      else
         echo "$FILE removed at $NAS"
         rm "$NAS/$FILE"  > /dev/null 2>&1
      fi
   fi
   X=`expr $X "+" 1`
   done
;;

sync | archive )
   if [ $# -gt 1 ]; then
      echo "$2" > $MYTMP
      sed -ie s!"'"!""!g /$MYTMP
      ARG=`cat $MYTMP`
      grep "$ARG" $NASTMP > $NASTMP2
      cp $NASTMP2 $NASTMP
      NASNUMBER=`cat $NASTMP | wc -l`
      grep "$ARG" $MOVIETMP > $MOVIETMP2
      cp $MOVIETMP2 $MOVIETMP
      MOVIENUMBER=`cat $MOVIETMP | wc -l`
   fi
   echo $LINE
   echo "synchronizing $ARG from $MOVIE to $NAS"
   echo "with linking *.ts, *.mpg and *.mpeg files"
   echo $LINE
   X=1
   cd $MOVIE
   while [ $X -le $MOVIENUMBER ]; do
   FILE=`head -n $X $MOVIETMP | tail -n 1`
   if [ ! -f "$NAS/$FILE" ]; then
      echo "Copying $FILE to $NAS"
      cp "$FILE" $NAS
   else
      ls -s "$FILE" >  $MTMP 
      sed -ie s!"$FILE"!""!g $MTMP
      cd $NAS
      ls -s "$FILE" >  $NTMP 
      sed -ie s!"$FILE"!""!g $NTMP
      cd $MOVIE
      MSIZE=`cat $MTMP`
      NSIZE=`cat $NTMP`
      if [ $NSIZE -lt $MSIZE ]; then
         echo "$FILE at $NAS seems incomplete or link, re-copy"
         rm "$NAS/$FILE" > /dev/null 2>&1
         cp "$FILE" $NAS
      else
         echo "$FILE already at $NAS"
      fi
   fi
   echo "$FILE" > $MTMP
   if [ `grep ".ts" $MTMP | wc -l` -gt 0 ]; then
      if [ `grep ".meta" $MTMP | wc -l` -lt 1 ]; then
         if [ `grep ".ap" $MTMP | wc -l` -lt 1 ]; then
            if [ `grep ".cuts" $MTMP | wc -l` -lt 1 ]; then
               if [ $NSIZE -eq $MSIZE ]; then
                  echo "$FILE is in sync, linking to $MOVIE"
                  rm "$FILE" > /dev/null 2>&1
                  ln -sfn "$NAS/$FILE"  
               else
                 if [ `ls -p "$MOVIE/$FILE" | grep "@" | wc -l` -gt 0 ]; then
                    echo "$FILE already linked"
                 else
                    echo "$FILE is not in sync, sorry"
                 fi
               fi
            fi
         fi
      fi
   fi
   if [ `grep ".mpeg" $MTMP | wc -l` -gt 0 ]; then
      if [ $NSIZE -eq $MSIZE ]; then
         echo "$FILE is in sync, linking to $MOVIE"
         rm "$FILE" > /dev/null 2>&1
         ln -sfn "$NAS/$FILE"  
      else
         if [ `ls -p "$MOVIE/$FILE" | grep "@" | wc -l` -gt 0 ]; then
            echo "$FILE already linked"
         else
            echo "$FILE is not in sync, sorry"
         fi
      fi
   fi
   if [ `grep ".mpg" $MTMP | wc -l` -gt 0 ]; then
      if [ $NSIZE -eq $MSIZE ]; then
         echo "$FILE is in sync, linking to $MOVIE"
         rm "$FILE" > /dev/null 2>&1
         ln -sfn "$NAS/$FILE"  
      else
         if [ `ls -p "$MOVIE/$FILE" | grep "@" | wc -l` -gt 0 ]; then
            echo "$FILE already linked"
         else
            echo "$FILE is not in sync, sorry"
         fi
      fi
   fi
   X=`expr $X "+" 1`
   done
   
#   echo $LINE
   X=1
   cd $NAS
   while [ $X -le $NASNUMBER ]; do
   FILE=`head -n $X $NASTMP | tail -n 1`
   ls -s "$FILE" >  $NTMP 
   if [ ! -f "$MOVIE/$FILE" ]; then
      if [ `grep ".eit" $NTMP | wc -l` -gt 0 ]; then
         echo "copying $FILE to $MOVIE"
         cp "$NAS/$FILE" $MOVIE
      fi
      if [ `grep ".meta" $NTMP | wc -l` -gt 0 ]; then
         echo "copying $FILE to $MOVIE"
         cp "$NAS/$FILE" $MOVIE
      fi
      if [ `grep ".ap" $NTMP | wc -l` -gt 0 ]; then
         echo "copying $FILE to $MOVIE"
         cp "$NAS/$FILE" $MOVIE
      fi
      if [ `grep ".cuts" $NTMP | wc -l` -gt 0 ]; then
         echo "copying $FILE to $MOVIE"
         cp "$NAS/$FILE" $MOVIE
      fi
      if [ `grep ".ts" $NTMP | wc -l` -gt 0 ]; then
         if [ `grep ".meta" $NTMP | wc -l` -lt 1 ]; then
            if [ `grep ".ap" $NTMP | wc -l` -lt 1 ]; then
               if [ `grep ".cuts" $NTMP | wc -l` -lt 1 ]; then
                  echo "linking $FILE to $MOVIE"
                  cd $MOVIE
                  ln -sfn "$NAS/$FILE"  
                  cd $NAS
              fi
            fi
         fi
      fi
      if [ `grep ".mpeg" $NTMP | wc -l` -gt 0 ]; then
         if [ $NSIZE -eq $MSIZE ]; then
            echo "$FILE is in sync, linking to $MOVIE"
            cd $MOVIE
            rm "$FILE" > /dev/null 2>&1
            ln -sfn "$NAS/$FILE"  
            cd $NAS
         else
            if [ `ls -p "$MOVIE/$FILE" | grep "@" | wc -l` -gt 0 ]; then
               echo "$FILE already linked"
            else
               echo "$FILE is not in sync, sorry"
            fi
         fi
      fi
      if [ `grep ".mpg" $NTMP | wc -l` -gt 0 ]; then
         if [ $NSIZE -eq $MSIZE ]; then
            echo "$FILE is in sync, linking to $MOVIE"
            cd $MOVIE
            rm "$FILE" > /dev/null 2>&1
            ln -sfn "$NAS/$FILE"  
            cd $NAS
         else
            if [ `ls -p "$MOVIE/$FILE" | grep "@" | wc -l` -gt 0 ]; then
               echo "$FILE already linked"
            else
               echo "$FILE is not in sync, sorry"
            fi
         fi
      fi
   fi
   X=`expr $X "+" 1`
   done
;;

usage | *)
echo $LINE
echo "Usage:"
echo "nassync.sh ls | lsmovie | rmmovie | rmnas lsnas | nsa2movie | movie2nas | sync"
echo $LINE
exit 1
;;
esac
echo $LINE
echo "$COMMAND Done !"
echo $LINE
exit 0
