#
# NASsync Plugin by gutemine
#
from Components.ScrollLabel import ScrollLabel
from enigma import eEPGCache, eTimer, eServiceReference
from ServiceReference import ServiceReference
from Screens.TimerEntry import TimerEntry
from time import localtime, asctime, time
from Components.AVSwitch import AVSwitch

from enigma import *
from Screens.Screen import Screen
from Screens.Standby import *
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList
from Components.Input import Input
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from Screens.ImageWizard import ImageWizard
from Screens.InfoBarGenerics import *
from ServiceReference import ServiceReference
from RecordTimer import *
from Screens.EventView import *
from time import *
from fcntl import ioctl
from struct import pack
#################
import os
import time
#import timer
import datetime
import codecs
from Tools import Directories, Notifications


from enigma import quitMainloop, eEPGCache, eServiceReference

import NavigationInstance

#############


nassync_pluginversion = "1.6"
nassync_readme = "/usr/lib/enigma2/python/Plugins/Extensions/NASsync/readme.txt"
nassync_script = "/usr/lib/enigma2/python/Plugins/Extensions/NASsync/nassync.sh"
nassync_nasdirectory = "/usr/lib/enigma2/python/Plugins/Extensions/NASsync/.nasdir"
nassync_moviedirectory = "/usr/lib/enigma2/python/Plugins/Extensions/NASsync/.moviedir"
nassync_tmp = "/tmp/.nassynctmp"

def autostart(reason, **kwargs):
        print "[NASsync] no autostart"
	
def Plugins(**kwargs):
	return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc = autostart),PluginDescriptor(name="NASsync", description="NAS Synchronisation Plugin", where = PluginDescriptor.WHERE_PLUGINMENU, icon="nassync.png", fnc=main)]
	
def main(session,**kwargs):
    try:    
     	session.open(NASsync)
    except:
        print "[NASsync] Pluginexecution failed"

class NASsync(Screen):
    skin = """
        <screen position="200,200" size="400,200" title="NAS Syncronisation Plugin Menu" >
            <widget name="menu" position="10,10" size="390,190" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, args = 0):
        self.skin = NASsync.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        list = []
        list.append(("NAS List and Status Options", "naslsoptions"))        
        list.append(("NAS Synchronisation Tasks", "nassyncoptions"))        
        list.append(("NAS Setup Menu", "nassyncsetup"))        
        list.append(("Show readme.txt", "nassyncreadme"))        
        list.append(("about", "aboutnassync"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.gonassync,"back": self.close,}, -1)
        
    def gonassync(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
           self.command=returnValue
           if returnValue is "nassyncoptions":
               NASSyncOptions(self.session)
           elif returnValue is "naslsoptions":
               NASListOptions(self.session)
           elif returnValue is "nassyncsetup":
               NASSetupOptions(self.session)
           elif returnValue is "nassyncreadme":
               self.session.open(Console,_("Showing NAS Syncronisation readme.txt"),["cat %s" % nassync_readme])
           elif returnValue is "aboutnassync":
               title1=_("NAS Synchronisation Plugin %s") % nassync_pluginversion
               title2=_("by gutemine is Freeware - use at your own risk !")
               title="%s\n%s" % (title1, title2)
               self.session.open(MessageBox,("%s") % (title),  MessageBox.TYPE_INFO)
           else:
               self.session.open(Console,_("Executing NAS Syncronisation: %s") % returnValue,["%s %s" %(nassync_script, returnValue)])

class NASSetupOptions(Screen):
    def __init__(self, session):
        self.session = session
	self.session.openWithCallback(self.NASEnterOption,InputBox, title=_("Please enter location of NAS"), text="/media/nas                      ", maxSize=35, type=Input.TEXT)

    def NASEnterOption(self,nasdir):
        if nasdir is None:
            self.skipNASSync(_("directory is none"))
        else:
            self.nasdir = nasdir.rstrip()
            if os.path.exists(self.nasdir) is True:
               self.session.openWithCallback(self.NASSetDir,MessageBox,_("are you sure to set NAS directory to %s ?") % (self.nasdir), MessageBox.TYPE_YESNO)
            else:
               self.session.open(MessageBox,_("NAS directory %s is not existing") % self.nasdir, MessageBox.TYPE_ERROR)
            
            
    def NASSetDir(self,answer):
        if answer is None:
            self.skipNASSync(_("answer is None"))
        if answer is False:
            self.skipNASSync(_("you were not confirming"))
        else:
            nasdirfile = open(nassync_nasdirectory, "w")
            nasdirfile.write("%s" % self.nasdir)
            nasdirfile.close()
            self.session.open(MessageBox,_("NAS directory was changed to %s") % self.nasdir, MessageBox.TYPE_INFO)
            
    def skipNASSync(self,reason):
        self.session.open(MessageBox,_("Setting NAS Synchronisation directory was canceled, because %s") % reason, MessageBox.TYPE_ERROR)

        
class NASListOptions(Screen):
    def __init__(self, session):
        self.session = session
        self.askForNASListMenu()
        
    def askForNASListMenu(self):
            self.session.openWithCallback(self.askForNASList,ChoiceBox,_("select NAS List and Synchronisation Status option"),self.getNASListMenuList())

    def askForNASList(self,command):
        if command is None:
            self.skipNASList(_("no option choosen"))
        else:
            self.command = command[1].rstrip()
            if self.command == "ls":
               self.session.openWithCallback(self.askForMovienameList,ChoiceBox,_("select a Movie for %s") % self.command, self.getListMovieNASList())
            elif self.command == "lsmovie":
               self.session.openWithCallback(self.askForMovienameList,ChoiceBox,_("select a Movie for %s") % self.command, self.getListMovieList())
            elif self.command == "lsnas":
               self.session.openWithCallback(self.askForMovienameList,ChoiceBox,_("select a Movie for %s") % self.command, self.getListNASList())
            elif self.command == "moviestatus":
               self.session.open(Console,_("Movie Synchronisation Status"), ["%s %s" %(nassync_script, self.command)])
            elif self.command == "fullstatus":
               self.session.open(Console,_("Full Synchronisation Status"), ["%s %s" %(nassync_script, self.command)])
            elif self.command == "crontab":
               self.session.open(Console,_("List NAS Syncronisation crontab Entries"), ["%s %s" %(nassync_script, self.command)])
            elif self.command == "rmcrontab":
               self.session.open(Console,_("Remove all NAS Syncronisation crontab Entries"), ["%s %s" %(nassync_script, self.command)])

    def askForMovienameList(self,movie):
        if movie is None:
            self.skipNASList(_("no movie choosen"))
        else:
            self.movie = movie[1]
            if self.command == "ls":
               self.session.open(Console,_("List of Movie and NAS Files"), ["%s %s '%s'" %(nassync_script, self.command, self.movie)])
            elif self.command == "lsmovie":
               self.session.open(Console,_("List of Movie Files"), ["%s %s '%s'" %(nassync_script, self.command, self.movie)])
            elif self.command == "lsnas":
               self.session.open(Console,_("List of NAS Files"), ["%s %s '%s'" %(nassync_script, self.command, self.movie)])

    def skipNASList(self,reason):
        self.session.open(MessageBox,_("NAS List option was canceled, because %s") % reason, MessageBox.TYPE_ERROR)
        
    def getListMovieNASList(self):
        moviename = []
        moviename.append(("all movies", ""))        
        
        if os.path.exists(nassync_moviedirectory) is True:
            moviedirfile = open(nassync_moviedirectory, "r")
            moviedir=moviedirfile.readline()
            moviedirfile.close()
        else:
            moviedir="/media/hdd/movie"
            
        for name in os.listdir(moviedir):
             if name.endswith(".ts") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpeg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
                
        if os.path.exists(nassync_nasdirectory) is True:
            nasdirfile = open(nassync_nasdirectory, "r")
            nasdir=nasdirfile.readline()
            nasdirfile.close()
        else:
            nasdir="/media/nas"
            
        for name in os.listdir(nasdir):
             if name.endswith(".ts") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpeg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
                
        return moviename

    def getListMovieList(self):
        moviename = []
        moviename.append(("all movies", ""))        
        
        if os.path.exists(nassync_moviedirectory) is True:
            moviedirfile = open(nassync_moviedirectory, "r")
            moviedir=moviedirfile.readline()
            moviedirfile.close()
        else:
            moviedir="/media/hdd/movie"
            
        for name in os.listdir(moviedir):
             if name.endswith(".ts") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpeg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
                
        return moviename

    def getListNASList(self):
        moviename = []
        moviename.append(("all movies", ""))        
        
        if os.path.exists(nassync_nasdirectory) is True:
            nasdirfile = open(nassync_nasdirectory, "r")
            nasdir=nasdirfile.readline()
            nasdirfile.close()
        else:
            nasdir="/media/nas"
            
        for name in os.listdir(nasdir):
             if name.endswith(".ts") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpeg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
                
        return moviename

    def getNASListMenuList(self):
        naslist = []
        naslist.append(("Movie Syncronisation Status", "moviestatus"))        
        naslist.append(("Full Syncronisation Status", "fullstatus"))        
        naslist.append(("List Movie and NAS Files", "ls"))        
        naslist.append(("List Movie Files", "lsmovie"))        
        naslist.append(("List NAS Files", "lsnas"))        
        naslist.append(("Remove all NAS Syncronisation crontab Entries", "rmcrontab"))        
        naslist.append(("List all NAS Syncronisation crontab Entries", "crontab"))        
        return naslist


class NASSyncOptions(Screen):
    def __init__(self, session):
        self.session = session
        self.askForNASSyncMenu()
        
    def askForNASSyncMenu(self):
            self.session.openWithCallback(self.askForNASSync,ChoiceBox,_("select NAS Copy and Synchronisation task"),self.getNASSyncMenuList())
            
    def askForNASSync(self,command):
        if command is None:
            self.skipNASSync(_("no option choosen"))
        else:
            self.command = command[1].rstrip()
            if self.command == "movie2nas":
               self.session.openWithCallback(self.askForMoviename,ChoiceBox,_("select a Movie for %s") % self.command, self.getSyncMovieList())
            elif self.command == "nas2movie":
               self.session.openWithCallback(self.askForMoviename,ChoiceBox,_("select a Movie for %s") % self.command, self.getSyncNASList())
            elif self.command == "sync":
               self.session.openWithCallback(self.askForMoviename,ChoiceBox,_("select a Movie for %s") % self.command, self.getSyncMovieNASList())
            elif self.command == "rmmovie":
               self.session.openWithCallback(self.askForMoviename,ChoiceBox,_("select a Movie for %s") % self.command, self.getSyncMovieList())
            elif self.command == "rmnas":
               self.session.openWithCallback(self.askForMoviename,ChoiceBox,_("select a Movie for %s") % self.command, self.getSyncNASList())

    def askForMoviename(self,movie):
        if movie is None:
            self.skipNASSync(_("no movie choosen"))
        else:
            self.movie = movie[1].rstrip()
            if self.command == "movie2nas":
	       self.session.openWithCallback(self.askForTime,InputBox,title=_("Enter Time in hours from 0..23, 99 is immediate"),text="99",maxSize=2, type=Input.NUMBER)        
            elif self.command == "nas2movie":
	       self.session.openWithCallback(self.askForTime,InputBox,title=_("Enter Time in hours from 0..23, 99 is immediate"),text="99",maxSize=2, type=Input.NUMBER)        
            elif self.command == "sync":
	       self.session.openWithCallback(self.askForTime,InputBox,title=_("Enter Time in hours from 0..23, 99 is immediate"),text="99",maxSize=2, type=Input.NUMBER)        
            elif self.command == "rmmovie":
               self.session.open(Console,_("Remove %s from Movie") % self.movie, ["%s %s \'%s\'" %(nassync_script, self.command, self.movie)])
            elif self.command == "rmnas":
               self.session.open(Console,_("Remove %s from NAS") % self.movie, ["%s %s \'%s\'" %(nassync_script, self.command, self.movie)])

    def skipNASSync(self,reason):
        self.session.open(MessageBox,_("NAS Copy and Syncronisation option was canceled, because %s") % reason, MessageBox.TYPE_ERROR)
        

    def getNASSyncMenuList(self):
        nassync = []
        nassync.append(("Copy Movie Files to NAS", "movie2nas"))        
        nassync.append(("Copy NAS Files to Movie", "nas2movie"))        
        nassync.append(("Synchronize Movie and NAS Files", "sync"))        
        nassync.append(("Remove NAS Files", "rmnas"))        
        nassync.append(("Remove Movie Files", "rmmovie"))        
        return nassync

    def getSyncMovieNASList(self):
        moviename = []
        moviename.append(("all movies", ""))        
        
        if os.path.exists(nassync_moviedirectory) is True:
            moviedirfile = open(nassync_moviedirectory, "r")
            moviedir=moviedirfile.readline()
            moviedirfile.close()
        else:
            moviedir="/media/hdd/movie"
            
        for name in os.listdir(moviedir):
             if name.endswith(".ts") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpeg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
                
        if os.path.exists(nassync_nasdirectory) is True:
            nasdirfile = open(nassync_nasdirectory, "r")
            nasdir=nasdirfile.readline()
            nasdirfile.close()
        else:
            nasdir="/media/nas"
            
        for name in os.listdir(nasdir):
             if name.endswith(".ts") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpeg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
                
        return moviename

    def getSyncMovieList(self):
        moviename = []
        moviename.append(("all movies", ""))        
        
        if os.path.exists(nassync_moviedirectory) is True:
            moviedirfile = open(nassync_moviedirectory, "r")
            moviedir=moviedirfile.readline()
            moviedirfile.close()
        else:
            moviedir="/media/hdd/movie"
            
        for name in os.listdir(moviedir):
             if name.endswith(".ts") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpeg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
                
        return moviename

    def getSyncNASList(self):
        moviename = []
        moviename.append(("all movies", ""))        
        
        if os.path.exists(nassync_nasdirectory) is True:
            nasdirfile = open(nassync_nasdirectory, "r")
            nasdir=nasdirfile.readline()
            nasdirfile.close()
        else:
            nasdir="/media/nas"
            
        for name in os.listdir(nasdir):
             if name.endswith(".ts") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
             if name.endswith(".mpeg") is True:
                sname=name.split(".ts")
                moviename.append(( sname[0], sname[0] ))
                
        return moviename

    def askForTime(self,shour):
        if shour is "":
            self.skipNAS(_("no Time entered"))
        elif shour is None:
            self.skipNAS(_("no Time entered"))
        elif int(shour)<0:
            self.skipNAS(_("Time should be 0..23" ))
        elif int(shour)>23 and int(shour) != 99:
            self.skipNAS(_("Time should be 0..23" ))
        else:
            if int(shour) == 99:
               self.shour = "*"
               self.session.openWithCallback(self.DoSynchronisation,MessageBox,_("sure to %s imeddiately ?" % (self.command)), MessageBox.TYPE_YESNO)
            else:
               self.shour = shour
               self.session.openWithCallback(self.DoSynchronisation,MessageBox,_("sure to %s at %sh ?" % (self.command,self.shour)), MessageBox.TYPE_YESNO)
            
    def DoSynchronisation(self,answer):
        if answer is None:
            self.skipNAS(_("nothing choosen"))
        elif answer is False:
            self.skipNAS(_("you were not confirming"))
        else:
               os.system("crontab -l > %s" % (nassync_tmp))
               if self.shour == "*": 
                  os.system("echo \"* %s * * * %s %s \'%s'\" >> %s" % (self.shour, nassync_script, self.command, self.movie, nassync_tmp))
               else:
                  os.system("echo \"0 %s * * * %s %s \'%s\'\" >> %s" % (self.shour, nassync_script, self.command, self.movie, nassync_tmp))
               os.system("crontab %s" % (nassync_tmp))
	       self.session.open(MessageBox,"Scheduled %s with crontab\ncheck Result with List and Status !" % self.command, MessageBox.TYPE_INFO)

    def skipNAS(self,reason):
        self.session.open(MessageBox,_("NAS Synchronisation was canceled, because %s") % reason, MessageBox.TYPE_WARNING)
        
